﻿@model eCommerce.UI.ViewModels.ShoppingCartViewModel
@using eCommerce.Services.Utils
@{
    ViewBag.Title = "Chequeá tu compra";
}

<div class="checkout shopping-cart">
    <div class="checkout__header">
        <div class="content__container">

            <div class="checkout__header-action -mobile">
                <a href="/shop"><i class="fa fa-long-arrow-left" aria-hidden="true"></i></a>
            </div>

            <h2 class="checkout__header-title">Chequéa tu compra</h2>
        </div>
    </div>

    @using (Html.BeginForm("Index", "ShoppingCart", FormMethod.Post, new { @class = "js-form" }))
    {
        <div class="checkout__body">
            <div class="content__container content__container-cart-content">
                <div class="shopping-cart__table cart-table">

                    <div class="cart-table__header">
                        <span class="cart-table__cell">Artículo</span>
                        <span class="cart-table__cell"></span>
                        <span class="cart-table__cell">Talle</span>
                        <span class="cart-table__cell">Color</span>
                        <span class="cart-table__cell">Unidades</span>
                        <span class="cart-table__cell">Precio</span>
                        <span class="cart-table__cell"></span>
                        <span class="cart-table__cell"></span>
                    </div>

                    <div class="cart-table__body">
                        @foreach (var od in Model.OrderDetails)
                        {
                            <div class="cart-table__row js-cart-item" data-orderdetailid="@od.OrderDetailId">
                                <div class="cart-table__cell cart-table__cell--image">
                                    <img class="cart-table__product-image" @*src="http://localhost:33158/Content/UploadDirectory/Products/Resized/5795/image_5e7fe6ad-b1d1-4813-9a51-8c06120e9e20.jpg"*@ src="@od.ProductImage" alt="@od.Title" />
                                </div>

                                <div class="cart-table__cell -desktop">
                                    <span class="cart-table__cell-info -desktop">@od.Title</span>
                                </div>
                                <div class="cart-table__cell -desktop">@od.SizeDescription</div>
                                <div class="cart-table__cell -desktop">@od.ColorDescription</div>
                                <div class="cart-table__cell cart-table__cell--product">
                                    <span class="cart-table__cell-info -mobile">@od.Title</span>
                                    <span class="cart-table__cell-info -mobile">@od.SizeDescription</span>
                                    <span class="cart-table__cell-info -mobile">@od.ColorDescription</span>
                                    @*<span class="cart-table__cell-info -mobile">x @od.Quantity</span>*@
                                    <input type="number" class="js-quantity cart-table__quantity" name="Quantity_@od.OrderDetailId" value="@od.Quantity" min="1" />
                                    <span class="cart-table__quantity-help hidden"></span>
                                </div>

                                <div class="cart-table__cell -desktop js-price">@od.Price.ToString("c2")</div>
                                <div class="cart-table__cell"><span class="js-message"></span></div>
                                <div class="cart-table__cell">
                                    <div class="cart-table__action"><span class="cart-table__price -mobile">@od.Price.ToString("c2")</span></div>
                                    <div class="cart-table__action underline js-clear-od"><span class="cart-table__action-text">Eliminar</span></div>
                                </div>
                            </div>
                        }
                    </div>
                </div>



                <div class="shopping-cart--summary">
                    <div class="cart-table__header">
                        <span class="cart-table__cell cart-table__cell-fit">Resumen de compra</span>
                    </div>
                    <div class="cart-table__body">
                        <div class="cart-table__row cart-table__row-noflex">
                            <div class="summary__subtotal js-subtotal">Subtotal<span id="summary__subtotal">@Model.TotalOrderDetails.ToString("c2")</span></div>
                            @if (Model.Discount > 0)
                            {
                                <div class="summary__discount js-discount"><span id="summary__text">Descuento</span><span id="summary__discount">@Model.Discount.ToString("c2")</span></div>
                            }
                            
                            @if (Model.ApplyIva)
                            {
                                <div class="summary__subtotal js-iva" data-use="@(Model.ApplyIva)">IVA<span id="summary__iva">@Model.IvaAmount.ToString("c2")</span></div>
                            }
                            <div class="summary-total">Total <span id="summary__total">@Model.Total.ToString("c2")</span></div>
                        </div>

                        @*<div class="cart-table__row">
                            <div class="checkout-summary__code" style="padding:0; border-bottom:none;">
                                <span class="checkout-code__title">¿Tenés un código de descuento?</span>
                                <div class="checkout-code__group">
                                    <label>Ingresalo acá</label>
                                    <div class="checkout-code__input-group">
                                        <input type="text" name="txtCoupon" id="txtCoupon" autocomplete="off" class="">
                                        <button type="button" class="summary-button" id="ApplyDiscount">Aplicar</button>
                                        <input type="hidden" name="Discount" id="Discount" value="0">
                                    </div>
                                </div>
                            </div>
                        </div>*@
                    </div>

                    <button style="width:100%;" type="button" @*href="/checkout"*@ class="button button--medium shopping-cart__button js-continue">Confirmar mi compra</button>
                </div>
            </div>

            <div class="content__container content__container-cart-content">
                <div class="shopping-cart__bottom">
                    <div class="shopping-cart__action -desktop">
                        <a href="/shop" class="cart-action__text"><i class="fa fa-long-arrow-left" aria-hidden="true"></i> Ver m&aacute;s productos</a>
                    </div>
                    <div class="flex js-clear-cart">
                        <div class="margin-right-1">Vaciar carrito</div>
                        <div class="cart-table__action cart-table__action-circle">
                            <span class="cart-table__action-text">X</span>
                        </div>
                    </div>


                    @*<div class="shopping-cart__summary">

                            <div class="cart-summary__item">
                                <span class="cart-summary__name">Total</span>
                                <span class="cart-summary__value">@Model.TotalOrderDetails.ToString("c2")</span>
                            </div>

                            <a href="/checkout" class="button button--large shopping-cart__button">Confirmar mi compra</a>
                        </div>*@
                </div>
            </div>
        </div>
    }

</div>


@section scripts{


    <script type="text/javascript">

        $(document).ready(function () {

            initializeForm();

            if ($('#summary__discount').text() == "0") {
                $('.summary__discount').css('display', 'none');
            }

            if ($('#summary__iva').text() == "0") {
                $('.js-iva').css('display', 'none');
            }

            //$('.js-subtotal').css('display', 'none');

            CheckCurrentPromotions();
        });

        function initializeForm()
        {
            //var pathArray = window.location.pathname.split('/');
            //var storeRoot = "/" + pathArray[1];

            var $form = $('.js-form');
            $form.attr('action',"/shopping-cart");
        }

        $('#ApplyDiscount').click(function () {
            validarCupon();
        });

        $('.js-clear-od').click(function ()
        {
            var elem = $(this).closest('.cart-table__row');

            var orderdetailid = elem.data('orderdetailid');

            $.ajax({
                type: "POST",
                cache: false,
                url:  "/ShoppingCart/Quitar",
                data: { orderDetailId: orderdetailid },
                success: function (data)
                {
                    if (data.success)
                    {
                        elem.remove();

                        /*updateCartTotals();
                        getTotal();*/

                        CheckCurrentPromotions();
                    }
                }
            });

        });

        function CheckCurrentPromotions()
        {
            $.ajax({
                type: "GET",
                cache: false,
                url:   "/ShoppingCart/CheckCurrentPromotions",
                data: { isIndex : true },
                success: function (data)
                {
                    if(data.Model.OrderDiscount != null && data.Model.OrderDiscount > 0)
                    {
                        //guardar el porcentaje en un hidden
                        $("#Discount").val(data.Model.OrderDiscount);

                        //Aplicar descuentos
                        ApplyItemsDiscount(data.Model.OrderDiscount);

                        //mostrar descuentos y subtotal
                        $('.js-subtotal').css('display', 'flex');
                        $('.summary__discount').css('display', 'flex');

                        $("#txtCoupon").prop('disabled', true);
                        $("#txtCoupon").css('cursor', 'not-allowed');
                    }
                    else
                    {
                        $("#Discount").val(0);
                        $('.summary__discount').css('display', 'none');

                        if (data.Model.results.length > 0)
                        {
                            $(data.Model.results).each(function(index, elem)
                            {
                                var orderDetailId = elem.OrderDetailId;
                                var message = elem.Message;
                                var price = elem.Price;

                                var $item = $('[data-orderdetailid="' + orderDetailId + '"]');
                                $item.find('.js-price').text(price).formatCurrency();
                                $item.find('.js-message').text(message);

                                if(message != '')
                                    $item.find('.js-message').toggleClass("message", true);
                                else
                                    $item.find('.js-message').toggleClass("message", false);
                            });
                        }
                    }

                    updateCartTotals();
                    getTotal();
                }
            });
        }

        $('.js-quantity').change(function () {
            var elem = $(this).closest('.cart-table__row');

            var orderdetailid = elem.data('orderdetailid');

            var quantity = $(this).val();

            if (quantity <= 0) {
                $(this).val(1);
                quantity = 1;
            }

            $.ajax({
                type: "POST",
                cache: false,
                url:  "/ShoppingCart/UpdateOrderDetailQuantity",
                data: { OrderDetailId: orderdetailid, Quantity: quantity},
                success: function (data)
                {
                    if (data.status = "ok") {
                        CheckCurrentPromotions();
                        updateCartTotals();
                        getTotal();
                    }
                }
            });

        });

        function getTotal() {

            var total = 0;

            $('.js-cart-item').each(function () {

                var quantity = $(this).find('.js-quantity').val();
                var price = $(this).find('.js-price').text().replace('$', '').replace('.', '');

                var totalOd = parseFloat(price) * quantity;
                total += totalOd;
            });

            $('#summary__subtotal').val(total);
            $('#summary__subtotal').text(total).formatCurrency();

            var applyIva = $('.js-iva').data('use') == "True";
            if(applyIva){
                var ivaAmount = total * @Utility.IVA_MULTIPLIER / 100;
                $('#summary__iva').val(ivaAmount);
                $('#summary__iva').text(ivaAmount).formatCurrency();

                total += ivaAmount;
            }

            $('#summary__total').val(total);
            $('#summary__total').text(total).formatCurrency();

            if ($('.summary__discount').css('display') == "flex") {
                ApplyItemsDiscount($('#summary__text').text().split(':')[1].replace('%',''));
            }

        }

        function validarCupon() {
            if ($("#Discount").val() == "0")
            {
                $.ajax({
                    type: "POST",
                    cache: false,
                    url:  "/ShoppingCart/ValidarCupon",
                    data: { cuponCode: $("#txtCoupon").val() },
                    success: function (data)
                    {
                        if (data == 0)
                        {
                            toastr.warning('El cupon ingresado es inválido');
                        }
                        else
                        {
                            debugger;

                            //guardar el porcentaje en un hidden
                            $("#Discount").val(data);

                            //Aplicar descuentos
                            ApplyItemsDiscount(data);
                            //ApplyDiscount(data);

                            //calcular totales
                            //GetSubTotal();

                            //mostrar descuentos y subtotal
                            $('.js-subtotal').css('display', 'flex');
                            $('.summary__discount').css('display', 'flex');

                            $("#txtCoupon").prop('disabled', true);
                            $("#txtCoupon").css('cursor', 'not-allowed');

                            toastr.success('¡La promoción se aplicó a tu carrito!');
                        }
                    }
                });
            }
        }

        function ApplyItemsDiscount(discount) {

            var subtotal = $('#summary__subtotal').text().replace('$', '').replace('.', '');

            $('#summary__text').text('Descuento:' + discount + '%');

            var discountValue = parseFloat(subtotal) * parseFloat(discount) / 100;

            $('#summary__discount').text(discountValue).formatCurrency();
            $('#summary__discount').val(discountValue);

            var total = parseFloat(subtotal) - parseFloat(discountValue);

            var applyIva = $('.js-iva').data('use') == "True";
            if(applyIva){
                var ivaAmount = total * @Utility.IVA_MULTIPLIER / 100;
                $('#summary__iva').val(ivaAmount);
                $('#summary__iva').text(ivaAmount).formatCurrency();

                total += ivaAmount;
            }

            $('#summary__total').text(total).formatCurrency();
            $('#summary__total').val(total);

        }

        $('.js-clear-cart').click(function () {

            swal({
                title: "Desea vaciar su carrito?",
                text: "",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: '#000',
                confirmButtonText: 'Sí, deseo vaciarlo',
                cancelButtonText: 'Cancelar',
                closeOnConfirm: false,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    ClearShoppingCart();
                }
            });

        });

        function ClearShoppingCart() {
            $.ajax({
                type: "POST",
                cache: false,
                url:  "/ShoppingCart/ClearShoppingCart",
                data: null,
                async: false,
                success: function (data) {
                    if (data.length == 0) {
                        location.reload();
                    }
                    else {
                        toastr.warning("Se produjo un error al intentar vaciar el carrito.");
                    }
                }
            });
        }

        $('.js-quantity').blur(function () {
            $(this).removeClass('cart-table__quantity--unavailable');
        });

        $(".js-form").keypress(function(e) {
            if (e.which == 13) {
                return false;
            }
        });

        $('.js-continue').click(function ()
        {
            debugger;
            var $form = $('.js-form');

            var data = $form.serializeArray();
            $.ajax({
                type: "POST",
                cache: false,
                url:  "/ShoppingCart/ValidarStock",
                data: data,
                async: false,
                success: function (data)
                {
                    if (data.length > 0) {
                        var msg = "Alguno de los productos no tiene stock suficiente.";
                        $('.js-quantity').removeClass('cart-table__quantity--unavailable');
                        $('.cart-table__quantity-help').addClass('hidden');
                        for (var i = 0; i < data.length; i++) {
                            var id = data[i][0];
                            var available_quantity = data[i][1];

                            $('.js-cart-item[data-orderdetailid=' + id + ']').find('.js-quantity').addClass('cart-table__quantity--unavailable');

                            var $help = $('.js-cart-item[data-orderdetailid=' + id + ']').find('.cart-table__quantity-help');
                            $help.removeClass('hidden');
                            $help.text('Cantidad disponible: ' + available_quantity);
                        }
                        toastr.warning(msg);
                    }
                    else
                    {
                        var subtotal = parseFloat($('#summary__subtotal').text().replace('$', '').replace('.', ''));

                        //var itemsCount = 0;
                        //$(".js-quantity").each(function() {
                        //    itemsCount += parseInt($(this).val());
                        //});

                        $.ajax({
                            type: "GET",
                            cache: false,
                            url:  "/ShoppingCart/ValidateOrderAmount",
                            //por cantidad
                            //data: { totaItems: itemsCount },

                            //por precio
                            data: { totalPrice: subtotal },
                            async: false,
                            success: function (data) {
                                if (!data.Valid) {
                                    swal({
                                        //title: 'Su pedido no cumple con el mínimo de compra requerido de ' + data.MinimumAmount + ' prendas.',
                                        title: 'Su pedido no cumple con el mínimo de compra requerido de $' + data.MinimumAmount,
                                        text: "",
                                        type: 'warning',
                                        confirmButtonColor: '#3085d6',
                                        cancelButtonColor: '#d33',
                                        confirmButtonText: 'OK',
                                    });
                                }
                                else {
                                   // swal({
                                   //     title: "Verificá los productos de tu carrito antes de confirmar tu compra.",
                                   //     text: "",
                                   //     type: "warning",
                                   //     showCancelButton: true,
                                   //     confirmButtonColor: '#000',
                                   //     confirmButtonText: 'Continuar',
                                   //     cancelButtonText: 'Cancelar',
                                   //     closeOnConfirm: false,
                                   //     closeOnCancel: true
                                   // },
                                   //function (isConfirm) {
                                   //    if (isConfirm) {
                                           $form.submit();
                                   //    }
                                   //}); 
                                }
                            }
                        });
                    }
                },
                error: function (a, b, c, d, e) {
                    debugger;
                }
            });
        });

    </script>




}